#ifndef __Function_h__
#define __Function_h__

#include <glib-object.h>

G_BEGIN_DECLS



#define HST_TYPE_FUNCTION                  (hst_function_get_type ())
#define HST_FUNCTION(obj)                  (G_TYPE_CHECK_INSTANCE_CAST ((obj), HST_TYPE_FUNCTION, HstFunction))
#define HST_FUNCTION_CLASS(klass)          (G_TYPE_CHECK_CLASS_CAST ((klass),  HST_TYPE_FUNCTION, HstFunctionClass))
#define HST_IS_FUNCTION(obj)               (G_TYPE_CHECK_INSTANCE_TYPE ((obj), HST_TYPE_FUNCTION))
#define HST_IS_FUNCTION_CLASS(klass)       (G_TYPE_CHECK_CLASS_TYPE ((klass),  HST_TYPE_FUNCTION))
#define HST_FUNCTION_GET_CLASS(obj)        (G_TYPE_INSTANCE_GET_CLASS ((obj),  HST_TYPE_FUNCTION, HstFunctionClass))

typedef struct Tuple_ Tuple;
typedef struct PointList_ PointList;
struct Tuple_ {
    int n;
    PointList *P;
};
struct PointList_ {
    double x;
    double y;
};


typedef struct _HstFunction HstFunction;
typedef struct _HstFunctionClass HstFunctionClass;

struct _HstFunction {
    GObject parent_instance;
    double (*func)(double);
    int    nbin;
    double xmin,xmax,step;
    gchar *name;
};

struct _HstFunctionClass {
    GObjectClass parent_class;
    
    double (*eval)(HstFunction *,double);
    void   (*array)(HstFunction *,Tuple *, double, double);
    int    (*resize)(HstFunction *,int w, int h);    

    /* signals */
    
    void (*range_changed)(HstFunction *);
};
typedef double (*Hst1DFunction)(double);

GType      hst_function_get_type (void) G_GNUC_CONST;
HstFunction *hst_function_new(int n, double xmin, double xmax, Hst1DFunction  ptr);
double     hst_function_eval(HstFunction *f,double x);
int        hst_function_npts(HstFunction *f);
double     hst_function_xmin(HstFunction *f);
double     hst_function_xmax(HstFunction *f);
double     hst_function_step(HstFunction *f);
int        hst_function_find_bin(HstFunction *f, double x);
double     hst_function_bin_center(HstFunction *f, int ib);
int        hst_function_resize(HstFunction *f,int width,int height);
gchar     *hst_function_get_name(HstFunction *f);
void       hst_function_set_name(HstFunction *f, gchar *name);
void       hst_function_get_array(HstFunction *f, Tuple *t, double xmin, double xmax);
void       hst_function_clear_tuple(Tuple *t);
G_END_DECLS
#endif
