#ifndef __Function2d_h__
#define __Function2d_h__

#include <gtk-hst/function.h>

G_BEGIN_DECLS

#define HST_TYPE_FUNCTION2D                  (function2d_get_type ())
#define HST_FUNCTION2D(obj)                  (G_TYPE_CHECK_INSTANCE_CAST ((obj), HST_TYPE_FUNCTION2D, HstFunction2D))
#define HST_FUNCTION2D_CLASS(klass)          (G_TYPE_CHECK_CLASS_CAST ((klass),  HST_TYPE_FUNCTION2D, HstFunction2DClass))
#define HST_IS_FUNCTION2D(obj)               (G_TYPE_CHECK_INSTANCE_TYPE ((obj), HST_TYPE_FUNCTION2D))
#define HST_IS_FUNCTION2D_CLASS(klass)       (G_TYPE_CHECK_CLASS_TYPE ((klass),  HST_TYPE_FUNCTION2D))
#define HST_FUNCTION2D_GET_CLASS(obj)        (G_TYPE_INSTANCE_GET_CLASS ((obj),  HST_TYPE_FUNCTION2D, HstFunction2DClass))

#define HST_FUNCTION2D_X(obj) (HST_FUNCTION(obj))
#define HST_FUNCTION2D_Y(obj) (HST_FUNCTION2D(obj)->Y)

typedef struct _HstFunction2D HstFunction2D;
typedef struct _HstFunction2DClass HstFunction2DClass;
struct _HstFunction2D {
    HstFunction X;
    HstFunction *Y;
    double (*func2d)(double,double);
};

struct _HstFunction2DClass {
    HstFunctionClass parent_class;
    
    double (*eval2d)(HstFunction2D *,double,double);
};

typedef double (*Hst2DFunction)(double,double);

GType           function2d_get_type (void) G_GNUC_CONST;
HstFunction2D  *hst_function2d_new(int n, double xmin, double xmax, int ny, double ymin, double ymax, Hst2DFunction ptr);
double          hst_function2d_eval(HstFunction2D *h2d,double x, double y);
int             hst_function2d_find_bin_from_cell(HstFunction2D *h2d, int ix,int iy);
void            hst_function2d_find_cell_from_bin(HstFunction2D *h2d, int ib , int *ix, int*iy);
HstFunction    *hst_function2d_X(HstFunction2D *h2d);
HstFunction    *hst_function2d_Y(HstFunction2D *h2d);

G_END_DECLS
#endif
