#ifndef __HstHistogram_h__
#define __HstHistogram_h__

#include <gtk-hst/function.h>
#include <gtk-hst/stats.h>

G_BEGIN_DECLS

#define HST_TYPE_HISTOGRAM                  (hst_histogram_get_type ())
#define HST_HISTOGRAM(obj)                  (G_TYPE_CHECK_INSTANCE_CAST ((obj), HST_TYPE_HISTOGRAM, HstHistogram))
#define HST_HISTOGRAM_CLASS(klass)          (G_TYPE_CHECK_CLASS_CAST ((klass),  HST_TYPE_HISTOGRAM, HstHistogramClass))
#define HST_IS_HISTOGRAM(obj)               (G_TYPE_CHECK_INSTANCE_TYPE ((obj), HST_TYPE_HISTOGRAM))
#define HST_IS_HISTOGRAM_CLASS(klass)       (G_TYPE_CHECK_CLASS_TYPE ((klass),  HST_TYPE_HISTOGRAM))
#define HST_HISTOGRAM_GET_CLASS(obj)        (G_TYPE_INSTANCE_GET_CLASS ((obj),  HST_TYPE_HISTOGRAM, HstHistogramClass))

typedef struct _HstHistogram HstHistogram;
typedef struct _HstHistogramClass HstHistogramClass;
struct _HstHistogram {
    HstFunction parent_instance;
    
    double *y;       /* array for bin contents */
    int     owner;   /* flag saying if we own the array */
    HstStats *stat;     /* statistics */

    double vmin,vmax; /* max. and min. values of bin contents */
};

struct _HstHistogramClass {
    HstFunctionClass parent_class;

    /* Functions */
    void (*fill)(HstHistogram *,double val, double weight);
    void (*reset)(HstHistogram *);

    /* signals */
    void (*changed)(HstHistogram *);
};

GType         hst_histogram_get_type (void) G_GNUC_CONST;
HstHistogram *hst_histogram_new(int n, double xmin, double xmax, gdouble *ptr);
void          hst_histogram_fill(HstHistogram *hst,double v, double w);
void          hst_histogram_reset(HstHistogram *hst);
void          hst_histogram_update_stats(HstHistogram *hst);
double        hst_histogram_mean(HstHistogram *hst);
double        hst_histogram_rms(HstHistogram *hst);
double        hst_histogram_stdev(HstHistogram *hst);
double        hst_histogram_n(HstHistogram *hst);
double        hst_histogram_xmin(HstHistogram *hst);
double        hst_histogram_xmax(HstHistogram *hst);
double        hst_histogram_vmin(HstHistogram *hst);
double        hst_histogram_vmax(HstHistogram *hst);
int           hst_histogram_get_stats(HstHistogram *hst, HstStats *s);
void          hst_histogram_get_buffer(HstHistogram *hst, int *sz, double **buffer);

G_END_DECLS
#endif
