#ifndef __HstProfile_h__
#define __HstProfile_h__

#include <gtk-hst/histogram.h>

G_BEGIN_DECLS

#define HST_TYPE_PROFILE                  (hst_profile_get_type ())
#define HST_PROFILE(obj)                  (G_TYPE_CHECK_INSTANCE_CAST ((obj), HST_TYPE_PROFILE, HstProfile))
#define HST_PROFILE_CLASS(klass)          (G_TYPE_CHECK_CLASS_CAST ((klass),  HST_TYPE_PROFILE, HstProfileClass))
#define HST_IS_PROFILE(obj)               (G_TYPE_CHECK_INSTANCE_TYPE ((obj), HST_TYPE_PROFILE))
#define HST_IS_PROFILE_CLASS(klass)       (G_TYPE_CHECK_CLASS_TYPE ((klass),  HST_TYPE_PROFILE))
#define HST_PROFILE_GET_CLASS(obj)        (G_TYPE_INSTANCE_GET_CLASS ((obj),  HST_TYPE_PROFILE, HstProfileClass))

typedef struct _HstProfile HstProfile;
typedef struct _HstProfileClass HstProfileClass;
struct _HstProfile {
    HstHistogram H;
    double *n;       /* counter */
    double *s;       /* array for bin variance */
};

struct _HstProfileClass {
    HstHistogramClass parent_class;

};

GType         hst_profile_get_type (void) G_GNUC_CONST;
HstProfile   *hst_profile_new(int n, double xmin, double xmax, gdouble *ptr);
void          hst_profile_fill(HstProfile *hst, double x, double y, double w);

G_END_DECLS
#endif
