#ifndef __STATS_H__
#define __STATS_H__

#include <glib.h>
#include <glib-object.h>

G_BEGIN_DECLS

/*
 * Type checking and casting macros
 */
#define HST_TYPE_STATS	          (hst_stats_get_type())
#define HST_STATS(obj)	          G_TYPE_CHECK_INSTANCE_CAST((obj), HST_TYPE_STATS, HstStats)
#define HST_STATS_CLASS(klass)    G_TYPE_CHECK_CLASS_CAST((klass), HST_TYPE_STATS, HstStatsClass)
#define HST_IS_STATS(obj)	  G_TYPE_CHECK_INSTANCE_TYPE((obj), HST_TYPE_STATS)

#define HST_STATS_GET_CLASS(obj)  G_TYPE_INSTANCE_GET_CLASS((obj), HST_TYPE_STATS, HstStatsClass)


enum {
   STATS_X=0,
   STATS_Y
};

typedef struct _HstStats HstStats;
struct _HstStats {
      GObject __parent__;
      double nc;
      double s[5];
      double xmin[2];	
      double xmax[2];
};

/*
 * Class definition
 */
typedef struct _HstStatsClass HstStatsClass;
struct _HstStatsClass {
      GObjectClass __parent__;
};


/*
 * Public methods
 */
GType hst_stats_get_type (void);
HstStats  *hst_stats_new();

gdouble hst_stats_get_nc (HstStats *self);

gdouble hst_stats_get_mean (HstStats *self, int w);
gdouble hst_stats_get_rms (HstStats *self, int w);
gdouble hst_stats_get_stdev (HstStats *self, int w);
gdouble hst_stats_get_min (HstStats *self, int w);
gdouble hst_stats_get_max (HstStats *self, int w);
gdouble hst_stats_get_correlation (HstStats *self);

void    hst_stats_add (HstStats *self, double x, double y, double w);
void    hst_stats_reset (HstStats *self);


G_END_DECLS
#endif
